# This file was auto-generated by Fern from our API Definition.

from ...base_types.types.paginated_response import PaginatedResponse
import typing
from .project_entity import ProjectEntity
from .project_entities_aggs import ProjectEntitiesAggs
from ...core.pydantic_utilities import IS_PYDANTIC_V2
import pydantic


class GetProjectEntitiesResponse(PaginatedResponse):
    """
    Examples
    --------
    from sayari.base_types import QualifiedCount
    from sayari.project import (
        BucketAgg,
        GetProjectEntitiesResponse,
        HsCodeAgg,
        HsCodeAggBucket,
        HsCodeAggTerms,
        IntKeyValue,
        ProjectEntitiesAggs,
        ProjectEntity,
        ProjectEntityUpstream,
        PsaSummary,
        TradeCount,
    )
    from sayari.shared_types import CoreEntity, RiskData, SourceCountInfo

    GetProjectEntitiesResponse(
        limit=10000,
        size=QualifiedCount(
            count=1,
            qualifier="eq",
        ),
        data=[
            ProjectEntity(
                id="GOeOE8",
                project="gPq6EY",
                label="RAMESH FLOWERS PRIVATE LIMITED",
                created="2024-03-08 18:52:59.41176+00",
                updated="2024-03-08 18:52:59.41176+00",
                updated_by="auth0|5e45bd8caccd890e68147513",
                version=0,
                entity_id="FyI9lrlmA-7z_3enlTOhlw",
                tag_ids=[],
                case_status="not_assigned",
                custom_fields={
                    "custom_company_size": "200+",
                    "custom_company_type": "flower services",
                },
                received_hs_codes=["271290", "271220"],
                shipped_hs_codes=[],
                combined_hs_codes=["271290", "271220"],
                trade_count_incl_mg=TradeCount(
                    receiver_of=5,
                    shipper_of=0,
                ),
                match_strength={
                    "rules": {
                        "is_strong_v1": False,
                        "any_v1": "",
                        "is_any_v1": False,
                        "strong_v1": "",
                        "is_weak_v1": False,
                        "weak_v1": "",
                        "strength_v1": "none",
                    }
                },
                upstream=ProjectEntityUpstream(
                    risk=[],
                    countries=[],
                    entities=0,
                    match_has_upstream={"FyI9lrlmA-7z_3enlTOhlw": False},
                    match_products={"FyI9lrlmA-7z_3enlTOhlw": []},
                ),
                psa=PsaSummary(
                    risk=[
                        "eu_high_risk_third",
                        "basel_aml",
                        "cpi_score",
                        "owner_of_regulatory_action_entity",
                    ],
                    countries=["USA", "CAN", "MAR", "BEL", "GEO"],
                    count=2,
                ),
                summary=CoreEntity(
                    id="FyI9lrlmA-7z_3enlTOhlw",
                    type="company",
                    label="RAMESH FLOWERS PRIVATE LIMITED",
                    identifiers=[],
                    addresses=[
                        "A62(A) SIPCOT INDUSTRIAL COMPLEX THERKU VEERAPANDIAPURAM P.O. TUTICORIN628002 TAMIL NADU INDIA GSTIN 33AAACR9251P1ZY IEC 3595005775 PANNO AAACR92",
                        "A62(A) SIPCOT INDUSTRIAL COMPLEX TUTICORIN628002 TAMIL NADU INDIA GSTIN 33AAACR9251P1ZY IEC 3595005775 PH914612340505 TO 2340509",
                    ],
                    countries=["IND"],
                    names=["RAMESH FLOWERS PRIVATE LIMITED"],
                    related_entities_count=8,
                    user_related_entities_count=0,
                    relationship_counts={
                        "notify_party_of": 5,
                        "receives_from": 3,
                        "receiver_of": 5,
                    },
                    user_relationship_counts={},
                    attribute_counts={"name": 1, "country": 1, "address": 2},
                    trade_count={"sent": 0, "received": 5},
                    user_attribute_counts={},
                    record_count=5,
                    user_record_count=0,
                    source_counts={
                        "faa9caafcfabcee04ef2f0b21dd9197a": SourceCountInfo(
                            count=10,
                            label="South Korea Imports & Exports (2021 - Present)",
                        )
                    },
                    risk={
                        "forced_labor_xinjiang_origin_subtier": RiskData(
                            value=3.0,
                            metadata={},
                            level="high",
                        ),
                        "basel_aml": RiskData(
                            value=4.95,
                            metadata={"country": ["IND"]},
                            level="relevant",
                        ),
                        "forced_labor_sheffield_hallam_university_reports_origin_subtier": RiskData(
                            value=3.0,
                            metadata={},
                            level="high",
                        ),
                        "cpi_score": RiskData(
                            value=40.0,
                            metadata={"country": ["IND"]},
                            level="relevant",
                        ),
                        "forced_labor_uflpa_origin_subtier": RiskData(
                            value=3.0,
                            metadata={},
                            level="high",
                        ),
                    },
                    attributes={
                        "address": [
                            {
                                "value": {
                                    "value": "A62(A) SIPCOT INDUSTRIAL COMPLEX THERKU VEERAPANDIAPURAM P.O. TUTICORIN628002 TAMIL NADU INDIA GSTIN 33AAACR9251P1ZY IEC 3595005775 PANNO AAACR92",
                                    "house": "Gstin 33aaacr9251p1zy",
                                    "house_number": "3595005775",
                                    "road": "Panno",
                                    "city": "NADU",
                                    "state": "Tamil Nadu",
                                    "postcode": "Aaacr92",
                                    "country": "India",
                                    "x": 74.99698,
                                    "y": 12.85316,
                                    "precision_code": "G3",
                                    "normalized": "33AAACR9251P1ZY 3595005775 A62A AAACR92 COMPLEX GSTIN IEC INDIA INDUSTRIAL NADU O P PANNO SIPCOT TAMIL THERKU TUTICORIN628002 VEERAPANDIAPURAM",
                                },
                                "properties": [
                                    {
                                        "record": "faa9caafcfabcee04ef2f0b21dd9197a/MAEU226738031/1693109172077",
                                        "record_count": 4,
                                        "editable": False,
                                    }
                                ],
                            },
                            {
                                "value": {
                                    "value": "A62(A) SIPCOT INDUSTRIAL COMPLEX TUTICORIN628002 TAMIL NADU INDIA GSTIN 33AAACR9251P1ZY IEC 3595005775 PH914612340505 TO 2340509",
                                    "house": "Gstin 33aaacr9251p1zy",
                                    "house_number": "3595005775",
                                    "road": "Ph914612340505 To 2340509",
                                    "city": "TO",
                                    "state": "Tamil Nadu",
                                    "postcode": "Tuticorin628002",
                                    "country": "India",
                                    "x": 77.06,
                                    "y": 20.00896,
                                    "precision_code": "G3",
                                    "normalized": "2340509 33AAACR9251P1ZY 3595005775 A62A COMPLEX GSTIN IEC INDIA INDUSTRIAL NADU PH914612340505 SIPCOT TAMIL TO TUTICORIN628002",
                                },
                                "properties": [
                                    {
                                        "record": "faa9caafcfabcee04ef2f0b21dd9197a/MAEU1KT860018/1693109343516",
                                        "record_count": 2,
                                        "editable": False,
                                    }
                                ],
                            },
                        ],
                        "country": [
                            {
                                "value": {
                                    "value": "IND",
                                    "context": "address",
                                    "Original Text": "India",
                                },
                                "properties": [
                                    {
                                        "record": "faa9caafcfabcee04ef2f0b21dd9197a/MAEU226738031/1693109172077",
                                        "record_count": 6,
                                        "editable": False,
                                    }
                                ],
                            }
                        ],
                        "name": [
                            {
                                "value": {
                                    "value": "RAMESH FLOWERS PRIVATE LIMITED",
                                    "context": "primary",
                                },
                                "properties": [
                                    {
                                        "record": "faa9caafcfabcee04ef2f0b21dd9197a/MAEU226738031/1693109172077",
                                        "record_count": 10,
                                        "editable": False,
                                    }
                                ],
                            }
                        ],
                    },
                ),
            )
        ],
        aggregations=ProjectEntitiesAggs(
            risk=[
                BucketAgg(
                    key="basel_aml",
                    doc_count=1,
                ),
                BucketAgg(
                    key="cpi_score",
                    doc_count=1,
                ),
                BucketAgg(
                    key="forced_labor_xinjiang_origin_subtier",
                    doc_count=1,
                ),
                BucketAgg(
                    key="forced_labor_uflpa_origin_subtier",
                    doc_count=1,
                ),
                BucketAgg(
                    key="forced_labor_sheffield_hallam_university_reports_origin_subtier",
                    doc_count=1,
                ),
            ],
            tag_ids=[],
            upstream_risk=[
                BucketAgg(
                    key="eu_high_risk_third",
                    doc_count=1,
                ),
                BucketAgg(
                    key="export_to_soe",
                    doc_count=4,
                ),
            ],
            hit_count=[
                BucketAgg(
                    key="hit_count",
                    doc_count=1,
                )
            ],
            country=[
                BucketAgg(
                    key="IND",
                    doc_count=1,
                    label="India",
                )
            ],
            shipment_counts=[
                BucketAgg(
                    key="receiver_of",
                    doc_count=5,
                    comment="Sum of all shipments of this type across matching documents",
                ),
                BucketAgg(
                    key="shipper_of",
                    doc_count=0,
                    comment="Sum of all shipments of this type across matching documents",
                ),
            ],
            source=[
                BucketAgg(
                    key="faa9caafcfabcee04ef2f0b21dd9197a",
                    label="South Korea Imports & Exports (2021 - Present)",
                    doc_count=1,
                )
            ],
            source_type=[
                BucketAgg(
                    key="trade_data",
                    doc_count=1,
                )
            ],
            region=[
                BucketAgg(
                    key="asia_pacific",
                    doc_count=1,
                )
            ],
            match_results=[
                BucketAgg(
                    key="sayari",
                    doc_count=1,
                )
            ],
            business_purpose=[],
            upstream_country=[
                BucketAgg(
                    key="USA",
                    doc_count=1,
                ),
                BucketAgg(
                    key="CAN",
                    doc_count=3,
                ),
            ],
            received_hs_codes=HsCodeAgg(
                doc_count=2,
                hs_code_terms=HsCodeAggTerms(
                    doc_count_error_upper_bound=0,
                    sum_other_doc_count=0,
                    buckets=[
                        HsCodeAggBucket(
                            key="271290",
                            doc_count=1,
                            hs_code_sums=IntKeyValue(
                                value=4,
                            ),
                        ),
                        HsCodeAggBucket(
                            key="271220",
                            doc_count=1,
                            hs_code_sums=IntKeyValue(
                                value=1,
                            ),
                        ),
                    ],
                ),
            ),
            custom_fields=[
                BucketAgg(
                    key="custom_id1",
                    doc_count=7,
                ),
                BucketAgg(
                    key="custom_size",
                    doc_count=15,
                ),
            ],
            custom_fields_count=IntKeyValue(
                value=2,
            ),
            case_statuses=[
                BucketAgg(
                    key="not_assigned",
                    doc_count=1,
                )
            ],
            upstream_country_tiers={
                "USA": {"tier2": 1},
                "CAN": {"tier1": 1, "tier2": 2},
            },
            upstream_risk_tiers={
                "eu_high_risk_third": {"tier4": 1},
                "export_to_soe": {"tier1": 1, "tier3": 1, "tier4": 2},
            },
            shipped_hs_codes=HsCodeAgg(
                doc_count=0,
                hs_code_terms=HsCodeAggTerms(
                    doc_count_error_upper_bound=0,
                    sum_other_doc_count=0,
                    buckets=[],
                ),
            ),
            combined_hs_codes=HsCodeAgg(
                doc_count=2,
                hs_code_terms=HsCodeAggTerms(
                    doc_count_error_upper_bound=0,
                    sum_other_doc_count=0,
                    buckets=[
                        HsCodeAggBucket(
                            key="271290",
                            doc_count=1,
                            hs_code_sums=IntKeyValue(
                                value=4,
                            ),
                        ),
                        HsCodeAggBucket(
                            key="271220",
                            doc_count=1,
                            hs_code_sums=IntKeyValue(
                                value=1,
                            ),
                        ),
                    ],
                ),
            ),
        ),
    )
    """

    next: typing.Optional[str] = None
    prev: typing.Optional[str] = None
    data: typing.List[ProjectEntity]
    aggregations: ProjectEntitiesAggs

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
